Index: src/edu/ucsb/nceas/metacat/IndexingQueue.java
===================================================================
--- src/edu/ucsb/nceas/metacat/IndexingQueue.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/IndexingQueue.java	(revision 4080)
@@ -32,7 +32,11 @@
 import java.util.Vector;
 import java.util.HashMap;
 import java.lang.Comparable;
-import edu.ucsb.nceas.metacat.MetaCatUtil;
+
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+
 import org.apache.log4j.Logger;
 
 public class IndexingQueue {
@@ -46,8 +50,20 @@
 	
 	private static IndexingQueue instance = null;
 
-	final static int NUMBEROFINDEXINGTHREADS = 
-		Integer.parseInt(MetaCatUtil.getOption("numberOfIndexingThreads"));
+	final static int NUMBEROFINDEXINGTHREADS;
+	static {
+		int numIndexingThreads = 0;
+		try {
+			numIndexingThreads = 
+				Integer.parseInt(PropertyService.getProperty("database.numberOfIndexingThreads"));
+		} catch (PropertyNotFoundException pnfe) {
+			System.err.println("Could not get property in static block: " 
+					+ pnfe.getMessage());
+		}
+		NUMBEROFINDEXINGTHREADS = numIndexingThreads;
+	}
+
+	
 	private int sleepTime = 2000; 
 
     private IndexingQueue() {
@@ -124,8 +140,21 @@
 
 class IndexingTask extends Thread {
   	  private Logger logMetacat = Logger.getLogger(IndexingTask.class);
-      protected final long MAXIMUMINDEXDELAY = Integer.
-      	parseInt(MetaCatUtil.getOption("maximumIndexDelay"));;
+  	  
+  	  
+      protected final static long MAXIMUMINDEXDELAY;
+      static {
+    	  long maxIndexDelay = 0;
+    	  try {
+    		  maxIndexDelay = 
+    			  Integer.parseInt(PropertyService.getProperty("database.maximumIndexDelay")); 
+    	  } catch (PropertyNotFoundException pnfe) {
+    		  System.err.println("Could not get property in static block: " 
+  					+ pnfe.getMessage());
+    	  }
+    	  MAXIMUMINDEXDELAY = maxIndexDelay;
+      }
+      
       protected boolean metacatRunning = true;
       	
 	  public void run() {
Index: src/edu/ucsb/nceas/metacat/advancedsearch/SearchServlet.java
===================================================================
--- src/edu/ucsb/nceas/metacat/advancedsearch/SearchServlet.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/advancedsearch/SearchServlet.java	(revision 4080)
@@ -36,7 +36,10 @@
 import javax.servlet.http.HttpSession;
 
 import edu.ucsb.nceas.metacat.client.*;
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.util.SystemUtil;
 import edu.ucsb.nceas.utilities.Options;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
 
 /** 
  * @author dcosta
@@ -108,28 +111,28 @@
   
 
   /**
-   * Initializes the servlet. Reads properties and initializes object fields.
-   * 
-   * @throws ServletException
-   */
-  public void init(ServletConfig config) throws ServletException {
-	ServletContext context = null;
-    String dirPath;
-    Options options = null;
+	 * Initializes the servlet. Reads properties and initializes object fields.
+	 * 
+	 * @throws ServletException
+	 */
+	public void init(ServletConfig config) throws ServletException {
+		ServletContext context = null;
+		String dirPath;
+		Options options = null;
 
-    super.init(config);
-    context = config.getServletContext();
-    dirPath = context.getRealPath(CONFIG_DIR);
-    File propertyFile = new File(dirPath, CONFIG_NAME);
-    
-    try {
-      options = Options.initialize(propertyFile);
-    }
-    catch (IOException e) {
-      System.err.println("Error in loading options: " + e.getMessage());
-    }
-    
-    this.contextString = options.getOption("context");
-  }
+		super.init(config);
+		context = config.getServletContext();
+		dirPath = context.getRealPath(CONFIG_DIR);
+		File propertyFile = new File(dirPath, CONFIG_NAME);
 
+		try {
+			options = Options.initialize(propertyFile);
+			this.contextString = PropertyService.getProperty("application.context");
+		} catch (IOException e) {
+			System.err.println("Error in loading options: " + e.getMessage());
+		} catch (PropertyNotFoundException pnfe) {
+			System.err.println("couldn't read property during initialization: "
+					+ pnfe.getMessage());
+		}
+	}
 }
Index: src/edu/ucsb/nceas/metacat/spatial/SpatialQuery.java
===================================================================
--- src/edu/ucsb/nceas/metacat/spatial/SpatialQuery.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/spatial/SpatialQuery.java	(revision 4080)
@@ -59,7 +59,7 @@
 
 import org.apache.log4j.Logger;
 
-import edu.ucsb.nceas.metacat.MetaCatUtil;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
 
 /** 
  * Class to query the persistent spatial cache
@@ -85,8 +85,8 @@
    * @param n North bounding coordinate 
    *
    */
-  public Vector filterByBbox( float w, float s, float e, float n ) {
-      Vector docids = new Vector();
+  public Vector<String> filterByBbox( float w, float s, float e, float n ) {
+      Vector<String> docids = new Vector<String>();
       SpatialFeatureSchema featureSchema = new SpatialFeatureSchema();
       
       ShapefileDataStore store = null;
Index: src/edu/ucsb/nceas/metacat/AssociateAccessPolicy.java
===================================================================
--- src/edu/ucsb/nceas/metacat/AssociateAccessPolicy.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/AssociateAccessPolicy.java	(revision 4080)
@@ -68,8 +68,7 @@
   private Vector docIdWithoutAccessEntry=null;
   private Vector notFoundDataSetId=null;
   private Vector itsDataSetIdWithouAccessEntry=null;
-  private Hashtable docIdMapDataSetId=null;
-  private MetaCatUtil util=null;
+  private Hashtable docIdMapDataSetId=null; 
   private Logger logMetacat = Logger.getLogger(AssociateAccessPolicy.class);
   
   /**
@@ -79,7 +78,6 @@
   {
      DBConnection localConn=null;
      int serialNumber = -1;
-     //MetaCatUtil localUtil=new MetaCatUtil();
      AssociateAccessPolicy policy=null;
      try
      {
@@ -145,7 +143,6 @@
     this.notFoundDataSetId=new Vector();
     this.itsDataSetIdWithouAccessEntry=new Vector();
     this.docIdMapDataSetId=new Hashtable();
-    this.util=new MetaCatUtil();
     getDocIdInAccessTable();
     getDocIdWithoutAccessEntry();
     getDocIdMapDataSetId();
Index: src/edu/ucsb/nceas/metacat/Version.java
===================================================================
--- src/edu/ucsb/nceas/metacat/Version.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/Version.java	(revision 4080)
@@ -23,38 +23,72 @@
  */
 package edu.ucsb.nceas.metacat;
 
+import java.util.Vector;
 
+import edu.ucsb.nceas.utilities.StringUtil;
+
+
 /**
  * @author jones
  *
  * Version represents the current version information for this Metacat instance.
  */
-public class Version
+public class Version implements Comparable<Version>
 {
+	protected static int allowedVersionLevels = 4;
+	protected int[] subversions = {0, 0, 0, 0}; 
+	protected String versionString = null;
+	
+	/**
+	 * Create a Version object, setting sub version levels based on the given
+	 * version id.
+	 * 
+	 * @param versionID
+	 */
+    public Version(String versionID) {
+    	setSubversions(versionID);
+    	versionString = versionID;
+    }
+	
     /**
-     * Get the current version string for this metacat instance.  
-     * It is currently stored in the metacat.properties file.
-     * 
-     * @return a string indicating the version of Metacat running
-     */
-    public static String getVersion()
-    {
-        String version = MetaCatUtil.getOption("version");
-        return version;
+	 * Compare this Version object to another. Use the sub version levels to do
+	 * the comparison. In that way, we can make sure that something like version
+	 * 1.0.0.1 is less than 2.0.1.
+	 * 
+	 * @param anotherVersion
+	 * @return -1 if this version is less than given version, 0 if they are
+	 *         equal and 1 if this version is greater than given version.
+	 */
+	public int compareTo(Version anotherVersion) {
+    	for (int i = 0; i < allowedVersionLevels; i++) {
+    		if (this.getSubversion(i) < ((Version)anotherVersion).getSubversion(i)) {
+    			return -1;
+    		} else if (this.getSubversion(i) > ((Version)anotherVersion).getSubversion(i)) {
+    			return 1;
+    		}
+    	}	
+		return 0;
     }
+	
+	public int getSubversion(int level) {
+		return subversions[level];
+	}
+	  
+	/**
+	 * Set each level (up to 4) of sub version based on the given version id.
+	 * 
+	 * @param versionID
+	 *            a string representing a dotted version notation
+	 */
+    private void setSubversions(String versionID) throws NumberFormatException {
+    	Vector<String> subversionStrings = StringUtil.toVector(versionID, '.');
+    	for (int i = 0; i < subversionStrings.size() && i < allowedVersionLevels; i++) {
+    		int subversion = Integer.parseInt(subversionStrings.elementAt(i));
+    		this.subversions[i] = subversion;
+    	}   	
+    }
     
-    /**
-     * Get the version number in an XML document.
-     * 
-     * @return the version wrapped in an XML document
-     */
-    public static String getVersionAsXml()
-    {
-        StringBuffer sb = new StringBuffer();
-        sb.append("<?xml version=\"1.0\"?>");
-        sb.append("<version>");
-        sb.append(Version.getVersion());
-        sb.append("</version>");
-        return sb.toString();
+    public String getVersionString() {
+    	return versionString;
     }
 }
Index: src/edu/ucsb/nceas/metacat/DBVersion.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBVersion.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/DBVersion.java	(revision 4080)
@@ -0,0 +1,62 @@
+/**
+ *  '$RCSfile$'
+ *  Copyright: 2008 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either DBVersion 2 of the License, or
+ * (at your option) any later DBVersion.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+package edu.ucsb.nceas.metacat;
+
+import java.util.Vector;
+
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.utilities.StringUtil;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+
+/**
+ * @author daigle@nceas.nceas.ucsb.edu
+ *
+ * DBVersion represents the current DBVersion information for this Metacat instance.
+ */
+public class DBVersion extends Version
+{
+	private Vector<String> updateScriptList = null;
+	
+	/**
+	 * Create a database version. Get the update script list from properties for
+	 * this version and save in a vector.
+	 * 
+	 * @param DBVersionId
+	 *            a string representing the version of the database.
+	 * @throws PropertyNotFoundException
+	 */
+    public DBVersion(String DBVersionId) throws PropertyNotFoundException {
+    	super(DBVersionId);
+		String updateScriptString = PropertyService.getProperty("database.upgradeVersion." + DBVersionId);
+    	updateScriptList = StringUtil.toVector(updateScriptString, ',');
+    }
+	
+    /**
+     * Get the update script list for this version
+     * @return a Vector of update script names.
+     */
+    public Vector<String> getUpdateScripts() {
+    	return updateScriptList;
+    }
+}

Index: src/edu/ucsb/nceas/metacat/DBSAXNode.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBSAXNode.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/DBSAXNode.java	(revision 4080)
@@ -35,6 +35,7 @@
 import org.xml.sax.SAXException;
 
 import edu.ucsb.nceas.dbadapter.AbstractDatabase;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
 
 /**
  * A Class that represents an XML node and its contents and
Index: src/edu/ucsb/nceas/metacat/service/SessionService.java
===================================================================
--- src/edu/ucsb/nceas/metacat/service/SessionService.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/service/SessionService.java	(revision 4080)
@@ -0,0 +1,115 @@
+/**
+ *  '$RCSfile$'
+ *    Purpose: A Class that implements session utility methods 
+ *  Copyright: 2008 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *    Authors: Michael Daigle
+ * 
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacat.service;
+
+import java.util.Hashtable;
+
+import javax.servlet.http.Cookie;
+import javax.servlet.http.HttpServletRequest;
+
+import org.apache.log4j.Logger;
+
+import edu.ucsb.nceas.metacat.util.SessionData;
+
+public class SessionService implements ServiceInterface {
+	
+	private static SessionService sessionService = null;
+	
+	private static Logger logMetacat = Logger.getLogger(SessionService.class);
+	private static Hashtable<String, SessionData> sessionHash = null;
+	
+	public static final String PUBLIC_SESSION_ID = "0";
+
+	/**
+	 * private constructor since this is a singleton
+	 */
+	private SessionService() {
+		sessionHash = new Hashtable<String, SessionData>();
+		registerSession(PUBLIC_SESSION_ID, "public", null, null);
+	}
+	
+	/**
+	 * Get the single instance of AuthAdmin.
+	 * 
+	 * @return the single instance of AuthAdmin
+	 */
+	public static SessionService getInstance() {
+		if (sessionService == null) {
+			sessionService = new SessionService();
+		}
+		return sessionService;
+	}
+		
+	public static void registerSession(String sessionId, String userName,
+			String[] groupNames, String password) {
+		SessionData sessionData = new SessionData(sessionId, userName, groupNames,
+				password);
+		sessionHash.put(sessionId, sessionData);
+	}
+	
+	public static void registerSession(SessionData sessionData) {
+		sessionHash.put(sessionData.getId(), sessionData);
+	}
+	
+	public static void unRegisterSession(String sessionId) {
+		sessionHash.remove(sessionId);
+	}
+	
+	public static boolean isSessionRegistered(String sessionId) {
+		return sessionHash.containsKey(sessionId);
+	}
+	
+	public static SessionData getRegisteredSession(String sessionId) {
+		return sessionHash.get(sessionId);
+	}
+	
+	public static String getSessionIDFromRequest(HttpServletRequest request) {
+		String sessionId = null;
+		Cookie[] cookies = request.getCookies();
+
+		if (cookies == null) {
+			return null;
+		}
+
+		for (int i = 0; i < cookies.length; i++) {
+			if (cookies[i].getName().equals("JSESSIONID")) {
+				sessionId = cookies[i].getValue();
+			}
+		}
+
+		logMetacat.debug("Request session ID: " + sessionId);
+		return sessionId;
+	}
+	
+	public static synchronized void touchSession(String sessionId) {
+		if (isSessionRegistered(sessionId)) {
+			SessionData sessionData = getRegisteredSession(sessionId);
+			sessionData.setLastAccessedTime();
+		}
+	}
+
+}

Index: src/edu/ucsb/nceas/metacat/DBUtil.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBUtil.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/DBUtil.java	(revision 4080)
@@ -47,6 +47,11 @@
 
 import org.apache.log4j.Logger;
 
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
+import edu.ucsb.nceas.metacat.util.SystemUtil;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+
 /**
  * A suite of utility classes for quering DB
  */
@@ -75,7 +80,6 @@
         try {
                     
           // Open a connection to the database
-          MetaCatUtil   util = new MetaCatUtil();
           //Connection dbconn = util.openDBConnection();
 
           DBUtil dbutil = new DBUtil();
@@ -166,7 +170,7 @@
    * read DTD or Schema file from Metacat's XML catalog system
    */
   public String readDTDSchema(String doctype)
-        throws SQLException, MalformedURLException, IOException
+        throws SQLException, MalformedURLException, IOException, PropertyNotFoundException
   {
     String systemID = null;
     PreparedStatement pstmt = null;
@@ -175,7 +179,7 @@
     int serialNumber = -1;
     // get doctype's System ID from db catalog
     try {
-      
+    
       dbConn=DBConnectionPool.
                   getDBConnection("DBUtil.readDTDSchema");
       serialNumber=dbConn.getCheckOutSerialNumber();
@@ -189,6 +193,10 @@
       boolean hasRow = rs.next();
       if (hasRow) {
         systemID = rs.getString(1);
+        // system id may not have server url on front.  Add it if not.
+        if (!systemID.startsWith("http://")) {
+        	systemID = SystemUtil.getServerURL() + systemID;
+        }
       } else {
         throw new SQLException("Non-registered doctype: " + doctype);
       }
@@ -337,7 +345,13 @@
         throws SQLException  {
 
     String accnum = null;
-    String sep = MetaCatUtil.getOption("accNumSeparator");
+    String sep = ".";
+    try {
+    	PropertyService.getProperty("accNumSeparator");
+    } catch (PropertyNotFoundException pnfe) {
+    	logMetacat.error("could not get property 'accNumSeparator'.  setting to '.': " 
+    			+ pnfe.getMessage());  	
+    }
     PreparedStatement pstmt = null;
     DBConnection dbConn = null;
     int serialNumber = -1;
@@ -430,7 +444,13 @@
         throws SQLException  {
     Vector resultVector = new Vector();
     String accnum = null;
-    String sep = MetaCatUtil.getOption("accNumSeparator");
+    String sep = ".";
+    try {
+    	PropertyService.getProperty("accNumSeparator");
+    } catch (PropertyNotFoundException pnfe) {
+    	logMetacat.error("could not get property 'accNumSeparator'.  setting to '.': " 
+    			+ pnfe.getMessage());  	
+    }
     PreparedStatement pstmt = null;
     DBConnection dbConn = null;
     int serialNumber = -1;
Index: src/edu/ucsb/nceas/metacat/util/SystemUtil.java
===================================================================
--- src/edu/ucsb/nceas/metacat/util/SystemUtil.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/util/SystemUtil.java	(revision 4080)
@@ -0,0 +1,290 @@
+/**
+ *  '$RCSfile$'
+ *    Purpose: A Class that implements system utility methods 
+ *  Copyright: 2008 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *    Authors: Michael Daigle
+ * 
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacat.util;
+
+import javax.servlet.ServletContext;
+import javax.servlet.http.HttpServletRequest;
+
+import org.apache.log4j.Logger;
+
+import edu.ucsb.nceas.metacat.MetaCatVersion;
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.utilities.FileUtil;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+
+public class SystemUtil {
+
+	private static Logger logMetacat = Logger.getLogger(SystemUtil.class);
+	private static String METACAT_SERVLET = "metacat";
+
+	/**
+	 * private constructor - all methods are static so there is no no need to
+	 * instantiate.
+	 */
+	private SystemUtil() {}
+
+	/**
+	 * Attempt to discover the server name. The name is retrieved from the http
+	 * servlet request. This is used by configuration routines before the port
+	 * has been populated in metacat.properties. it is possible the port that
+	 * the user configures might be different than the name we get here. You
+	 * should use getServerPort() instead of this method whenever possible.
+	 * 
+	 * @param request
+	 *            the http servlet request we will use to find the server name
+	 * 
+	 * @return a string holding the server name
+	 */
+	public static String discoverServerName(HttpServletRequest request) {
+		String serverName = request.getServerName();
+
+		return serverName;
+	}
+
+	/**
+	 * Attempt to discover the server port. The port is retrieved from the http
+	 * servlet request. This is used by configuration routines before the port
+	 * has been populated in metacat.properties. it is possible the port that
+	 * the user configures might be different than the port we get here. You
+	 * should use getServerPort() instead of this method whenever possible.
+	 * 
+	 * @param request
+	 *            the http servlet request we will use to find the server port
+	 * 
+	 * @return a string holding the server port
+	 */
+	public static String discoverServerPort(HttpServletRequest request) {
+		return Integer.toString(request.getServerPort());
+	}
+	
+	/**
+	 * Attempt to discover the server ssl port. The ssl port is assumed using
+	 * the standard port. This is used by configuration routines before the port
+	 * has been populated in metacat.properties. it is possible the prot that
+	 * the user configures might be different than the port we get here. You
+	 * should use getServerSSLPort() instead of this method whenever possible.
+	 * 
+	 * @param request
+	 *            the http servlet request we will use to find the server port
+	 * 
+	 * @return a string holding the server ssl port
+	 */
+	public static String discoverServerSSLPort(HttpServletRequest request) {
+		String serverPort = discoverServerPort(request);
+
+		if (serverPort.length() == 4 && serverPort.charAt(0) == '8') {
+			return "8443";
+		}
+
+		return "443";
+	}
+
+	/**
+	 * Get the server URL which is made up of the server name + : + the http
+	 * port number. Note that if the port is 80, it is left off.
+	 * 
+	 * @return string holding the server URL
+	 */
+	public static String getServerURL() throws PropertyNotFoundException {
+		String ServerURL = "http://" + PropertyService.getProperty("server.name");
+		String httpPort = PropertyService.getProperty("server.httpPort");
+		if (!httpPort.equals("80")) {
+			ServerURL += ":" + httpPort;
+		}
+
+		return ServerURL;
+	}
+
+	/**
+	 * Get the secure server URL which is made up of the server name + : + the
+	 * https port number. Note that if the port is 443, it is left off.
+	 * 
+	 * @return string holding the server URL
+	 */
+	public static String getSecureServerURL() throws PropertyNotFoundException {
+		String ServerURL = "https://" + PropertyService.getProperty("server.name");
+		String httpPort = PropertyService.getProperty("server.httpSSLPort");
+		if (!httpPort.equals("443")) {
+			ServerURL = PropertyService.getProperty("server.name") + ":" + httpPort;
+		}
+
+		return ServerURL;
+	}
+
+	/**
+	 * Get the CGI URL which is made up of the server URL + file separator + the
+	 * CGI directory
+	 * 
+	 * @return string holding the server URL
+	 */
+	public static String getCGI_URL() throws PropertyNotFoundException{
+		return getServerURL() + FileUtil.getFS()
+				+ PropertyService.getProperty("application.cgiDir");
+	}
+
+	/**
+	 * Get the server URL with the context. This is made up of the server URL +
+	 * file separator + the context
+	 * 
+	 * @return string holding the server URL with context
+	 */
+	public static String getContextURL() throws PropertyNotFoundException {
+		return getServerURL() + FileUtil.getFS()
+				+ PropertyService.getProperty("application.context");
+	}
+
+	/**
+	 * Get the servlet URL. This is made up of the server URL with context +
+	 * file separator + the metacat servlet name
+	 * 
+	 * @return string holding the servlet URL
+	 */
+	public static String getServletURL() throws PropertyNotFoundException {
+		return getContextURL() + FileUtil.getFS() + METACAT_SERVLET;
+	}
+
+	/**
+	 * Get the style skins URL. This is made up of the server URL with context +
+	 * file separator + "style" + file separator + "skins"
+	 * 
+	 * @return string holding the style skins URL
+	 */
+	public static String getStyleSkinsURL() throws PropertyNotFoundException {
+		return getContextURL() + FileUtil.getFS() + "style" + FileUtil.getFS()
+				+ "skins";
+	}
+
+	/**
+	 * Get the style common URL. This is made up of the server URL with context +
+	 * file separator + "style" + file separator + "common"
+	 * 
+	 * @return string holding the style common URL
+	 */
+	public static String getStyleCommonURL() throws PropertyNotFoundException {
+		return getContextURL() + FileUtil.getFS() + "style" + FileUtil.getFS()
+				+ "common";
+	}
+	
+	/**
+	 * Get the metacat version by getting the string representation from
+	 * metacat.properties and instantiating a MetaCatVersion object
+	 * 
+	 * @return a MetaCatVersion object holding metacat version information
+	 */
+	public static MetaCatVersion getMetacatVersion() throws PropertyNotFoundException {
+		String metacatVersionString = 
+			PropertyService.getProperty("application.metacatVersion");
+		return new MetaCatVersion(metacatVersionString);
+	}
+
+	/**
+	 * Get the context directory. This is made up of the tomcat directory + file
+	 * separator + "webapps" + file separator + context
+	 * 
+	 * @return string holding the context directory
+	 */
+	public static String getContextDir() throws PropertyNotFoundException {
+		return PropertyService.getProperty("application.tomcatDir") + FileUtil.getFS()
+				+ "webapps" + FileUtil.getFS()
+				+ PropertyService.getProperty("application.context");
+	}
+
+	/**
+	 * Attempt to discover the context for this application. This is a best
+	 * guess scenario. It is used by configuration routines before the context
+	 * has been populated in metacat.properties. You should always use
+	 * getApplicationContext() instead of this method if possible.
+	 * 
+	 * @param request
+	 *            the http servlet request we will use to find the context
+	 * 
+	 * @return a string holding the context
+	 */
+	public static String discoverApplicationContext(HttpServletRequest request) {
+		String contextPath = request.getContextPath();
+
+		if (contextPath.charAt(0) == '/') {
+			contextPath = contextPath.substring(1);
+		}
+		logMetacat.debug("contextPath: " + contextPath);
+
+		return contextPath;
+	}
+
+	/**
+	 * Get the style skins directory. This is made up of the tomcat directory
+	 * with context + file separator + "style" + file separator + "skins"
+	 * 
+	 * @return string holding the style skins directory
+	 */
+	public static String getStyleSkinsDir() throws PropertyNotFoundException {
+		return getContextDir() + FileUtil.getFS() + "style" + FileUtil.getFS()
+				+ "skins";
+	}
+
+	/**
+	 * Get the SQL directory. This is made up of the context directory + file
+	 * separator + sql
+	 * 
+	 * @return string holding the sql directory
+	 */
+	public static String getSQLDir() throws PropertyNotFoundException {
+		return getContextDir() + FileUtil.getFS() + "sql";
+	}
+
+	/**
+	 * Get the default style URL from metacat.properties.
+	 * 
+	 * @return string holding the default style URL
+	 */
+	public static String getDefaultStyleURL() throws PropertyNotFoundException {
+		return getStyleCommonURL() + FileUtil.getFS()
+				+ PropertyService.getProperty("application.default-style");
+	}
+
+	/**
+	 * Attempt to discover the Tomcat directory for this application. This is a
+	 * best guess scenario. It is used by configuration routines before the
+	 * tomcat directory has been populated in metacat.properties. You should always
+	 * use getTomcatDir() instead of this method if possible.
+	 * 
+	 * @param request
+	 *            the http servlet request we will use to find the tomcat directory
+	 * 
+	 * @return a string holding the tomcat directory
+	 */
+	public static String discoverTomcatDir(HttpServletRequest request) {
+		ServletContext servletContext = request.getSession()
+				.getServletContext();
+		String realPath = servletContext.getRealPath(".");
+
+		int webappIndex = realPath.indexOf("webapp");
+
+		return realPath.substring(0, webappIndex - 1);
+	}
+
+}

